diff options
Diffstat (limited to 'test/scripts/run_with_cleanup.sh')
-rwxr-xr-x | test/scripts/run_with_cleanup.sh | 25 |
1 files changed, 25 insertions, 0 deletions
diff --git a/test/scripts/run_with_cleanup.sh b/test/scripts/run_with_cleanup.sh new file mode 100755 index 00000000000..dcaa58b4498 --- /dev/null +++ b/test/scripts/run_with_cleanup.sh @@ -0,0 +1,25 @@ +#!/bin/bash + +rv=0 + +atexit() { + group_id=`ps -p $$ -o pgid=` + my_id=$$ + ids=`pgrep -g $group_id -d ' ' | sed "s/\b$my_id\b//g"` + echo "Killing possible remaining process IDs: $ids" + for id in $ids + do + if ps -p $id > /dev/null + then + kill -9 $id + fi + done + exit $rv +} + +trap "atexit" SIGINT SIGTERM + +$* +rv=$? +atexit +exit $rv |